質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

88.59%

python ssh接続がうまくいきません。教えてください。

解決済

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 2,675

 前提・実現したいこと

python初心者です。
SSH接続を行いたいのですが、下記のようなエラーが発生しました。
該当のソースコードはネットで調べた内容をそのまま使っています。

 発生している問題・エラーメッセージ

Unknown exception: DLL load failed: このオペレーティング システムでは %1 は実行されません。
Traceback (most recent call last):
...

 該当のソースコード

import paramiko

client = paramiko.SSHClient()
client.set_missing_host_key_policy(paramiko.WarningPolicy())
client.connect('X.XXX.XX.X', port=YYYY, username='user', password='pass')

stdin, stdout, stderr = client.exec_command('uname -a')
for line in stdout:
    print(line)

client.close()

#### pip install paramiko の応答 ####

C:\Users\XXXX>pip install paramiko
Collecting paramiko
  Using cached https://files.pythonhosted.org/packages/cf/ae/94e70d49044ccc234bf
dba20114fa947d7ba6eb68a2e452d89b920e62227/paramiko-2.4.2-py2.py3-none-any.whl
Requirement already satisfied: bcrypt>=3.1.3 in c:\users\XXXX\anaconda3\lib\site
-packages (from paramiko) (3.1.4)
Requirement already satisfied: cryptography>=1.5 in c:\users\XXXX\anaconda3\lib\
site-packages (from paramiko) (2.3.1)
Requirement already satisfied: pyasn1>=0.1.7 in c:\users\XXXX\anaconda3\lib\site
-packages (from paramiko) (0.4.4)
Requirement already satisfied: pynacl>=1.0.1 in c:\users\XXXX\anaconda3\lib\site
-packages (from paramiko) (1.3.0)
Requirement already satisfied: six>=1.4.1 in c:\users\XXXX\anaconda3\lib\site-pa
ckages (from bcrypt>=3.1.3->paramiko) (1.11.0)
Requirement already satisfied: cffi>=1.1 in c:\users\XXXX\anaconda3\lib\site-pac
kages (from bcrypt>=3.1.3->paramiko) (1.11.5)
Requirement already satisfied: idna>=2.1 in c:\users\XXXX\anaconda3\lib\site-pac
kages (from cryptography>=1.5->paramiko) (2.7)
Requirement already satisfied: asn1crypto>=0.21.0 in c:\users\XXXX\anaconda3\lib
\site-packages (from cryptography>=1.5->paramiko) (0.24.0)
Requirement already satisfied: pycparser in c:\users\XXXX\anaconda3\lib\site-pac
kages (from cffi>=1.1->bcrypt>=3.1.3->paramiko) (2.18)
twisted 18.7.0 requires PyHamcrest>=1.9.0, which is not installed.
Installing collected packages: paramiko
Successfully installed paramiko-2.4.2
You are using pip version 10.0.1, however version 18.1 is available.
You should consider upgrading via the 'python -m pip install --upgrade pip' comm
and.

 試したこと

・Anacondaの再インストール
・「python ssh接続」で検索し出てきた様々なコードの実装

pip list で確認したところ、リストの中にparamikoはありました。
エラーコードで検索してもヒットしなかったため、質問させていただきます。

 補足情報(FW/ツールのバージョンなど)

python3.7.0

参考にしたサイトのURL:https://techacademy.jp/magazine/18882
paramikoのインストールは上記のサイトに記述してある様に、pip install で行っています。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • can110

    2018/12/01 18:45

    追記ありがとうございます。pip install paramiko実行時のログを追記ください(一度uninstallが必要です)。関連モジュールのインストール状況が分かります。

    キャンセル

  • python_studyMan

    2018/12/02 01:23

    ありがとうございます。概要ソースコードの下に追記いたしました。よろしくお願いします。

    キャンセル

  • can110

    2018/12/02 03:53

    追記ありがとうございます。特に問題ないようですね…

    キャンセル

回答 1

checkベストアンサー

0

インストールログからは問題がないように見受けられます。
いちどcondaでのインストールを試してみてはいかがでしょうか。

  1. pip uninstall paramikoを実行。既存のparamikoをアンインストールする。
  2. anaconda search -t conda paramikoを実行。anaconda/paramikoが見つかる。
  3. anaconda show anaconda/paramikoを実行。最後にインストールコマンドが表示される。
  4. conda install --channel https://conda.anaconda.org/anaconda paramikoを実行する。

当方(Win10+Anaconda)ではpipインストールでも問題ありませんでしたが
あらためて上記手順でcondaインストールしコード実行できました。

参考URL:
Anaconda3から導入したPython環境でPyQt5が使えない:pipインストールにてDLL欠損が原因。conda経由でインストールし解決。
Anacondaの使い方 その2 (環境構築コマンド&ライブラリインストール):パッケージの探し方&インストールコマンドの表示方法

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/12/02 09:10

    回答ありがとうございます。
    その方法で試してみましたが同じようなエラーになりました。他の方法(別サイトのソースコード)でもほぼ同様の結果になるため、サーバーの管理者に問い合わせてみます。
    長らくの対応ありがとうございました。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 88.59%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る